﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	
#End Region

Sub Process_Globals
	
	Type Messagesms (Address As String, Body As String)
	Private Counter As Int = 0
	Dim Send_Sms As PhoneSms
	Dim str As ByteConverter
	Dim Access As String = "0000"
	Dim file_name As String="Setup.json"
	Dim Read_data As List
	
	Public MessageCompleted As Boolean=False
	Public TypeMessage As Int=0
	
	Private jg As JSONGenerator
	Private JSON As JSONParser
	Private GeneralAdmin As Map
	Private HeaterCommand As Map
	Public SchedulerCommand As List
	

	Dim hg As PhoneEvents
	Private AdminNumber,Adminpassword As String
	Private AdminUserPhone As List
	
	Private SchedulerId As String
	Private SchedulerDays As List
	Private SchedulerRepeat As String
	Private SchedulerActive As String
	Private SchedulerDate As String
	Private SchedulerTemp As String
	
	Private ErrorMessage As String
	
	Private Sep1 As String="/"
	Private Sep2 As String=";"
	
	Private TypeSchedulerAction As Int=0
	Private CreateScheduler As Int =1
	Private ModifScheduler As Int =2
	Private SupScheduler As Int =3
	
		
	Dim Phone1,Active_Phone1,Phone2,Active_Phone2,ActivePhone1,ActivePhone2,Admin_Code,Admin_Message1,Admin_Message2,Localisation,Welcome_Message1,Welcome_Message2,Welcome_Message3 As String
	Dim Start_Date, Stop_Date, Start_Time, Stop_Time As Long
	Dim First_Name, Last_Name, Email, Phone, City, Door_Code,Battery_Level As String
	Dim Wifi_Enable, BLE_Enable As Boolean
	Dim Wifi As MLwifi
	
	Public Admin As BluetoothAdmin
	Public BluetoothState As Boolean=True
	Public BluetoothState_off As Boolean=False
	Dim inst As Intent
	
	Dim RentalId As String
End Sub

Sub Service_Create
	
	' Load Setup
	Read_data.Initialize
	GeneralAdmin.Initialize
	SchedulerCommand.Initialize
	HeaterCommand.Initialize
	AdminUserPhone.Initialize
	SchedulerDays.Initialize
	Json_setup(False) 'Chargement du Setup
	
	wait for (ReadSchedulerFile) complete  (Returnl As Boolean)
	
	
	
	'Service_Command("#Or001#%123456%dksf788815az%")
	
	
	'Initialise une instance Bluetooth pour gérer le on/off
	
'	If inst.IsInitialized=False Then
'		inst.Initialize("android.settings.BLUETOOTH_SETTINGS", "")
'		StartActivity(inst)
'	End If
'	
'		
'	Admin.Initialize("admin")
	
	
	hg.Initialize("hg")
End Sub

'*************Load Scheduler*************
Sub ReadSchedulerFile As ResumableSub
	Try
		wait for (JsonFileAction.Read_JSONfile("scheduler.json")) complete  (ReturnlList As List)
		SchedulerCommand= ReturnlList
		Return True
	Catch
		Log(LastException)
		Return False
	End Try
	
	
End Sub

Sub Service_Start(startingIntent As Intent)
		
	If startingIntent.Action = "android.provider.Telephony.SMS_RECEIVED" Then
		Dim messages() As Messagesms
		messages = ParseSmsIntent(startingIntent)
		
		For i = 0 To messages.Length - 1
			Dim mess As String = messages(i).Body 'FullMessage(1).SubString(6)
			Service_Command(mess)
			Log(messages(i))
		Next
	End If
	'StartService(SchedulerAgent)
	Service.StopAutomaticForeground
End Sub

Private Sub Admin_StateChanged (NewState As Int, OldState As Int)
	Log("state changed: " & NewState)
	BluetoothState = NewState = Admin.STATE_ON
	BluetoothState_off = NewState = Admin.STATE_OFF
	
	If BluetoothState=True Then 'Lance le scan après avoir démarré le Bluetooth
		
	else If BluetoothState_off = True Then
		
	End If
	
End Sub

'Sub Command(Nbre_Pulse As Int)
'	
'	' Envoi de la trame audio
'	
'	Do While Counter < Nbre_Pulse
'		CallSub3(Starter, "Beep", 1000, 1000)
'		Sleep(3000) 'Délai entre chaque pulse
'		Counter= Counter+1
'	Loop
'	
'End Sub

' Chargement Setup
Sub Json_setup(Mode As Boolean) 'False/True = Read/Write
	
	' Chargement du Setup
	Try
		If Mode=False Then
			JSON.Initialize(File.ReadString(File.DirDefaultExternal, "Setup.json"))
				
			GeneralAdmin = JSON.NextObject
				
			AdminNumber=GeneralAdmin.Get("AdminNumber")
			Adminpassword=GeneralAdmin.Get("Adminpassword")
			AdminUserPhone=GeneralAdmin.Get("AdminUserPhone")
			
		
		Else If Mode=True Then
		
			Dim GeneralAdminSetup As Map
		
			GeneralAdminSetup.Initialize
			GeneralAdminSetup.put("AdminNumber",AdminNumber)
			GeneralAdminSetup.put("Adminpassword",Adminpassword)
			GeneralAdminSetup.Put("AdminUserPhone",AdminUserPhone)
		
				
			jg.Initialize(GeneralAdminSetup)
		
			File.WriteString(File.DirDefaultExternal,"Setup.json",jg.ToPrettyString(4))
		End If
	
	Catch
		Log(LastException)
	End Try
	
	
		
		
		
	
End Sub

'Parses an SMS intent and returns an array of messages
Sub ParseSmsIntent (in As Intent) As Messagesms()
	
	' Détection reception SMS et lecture
	Dim messages() As Messagesms
	If in.HasExtra("pdus") = False Then Return messages
	Dim pdus() As Object
	Dim r As Reflector
	pdus = in.GetExtra("pdus")
	If pdus.Length > 0 Then
		Dim messages(pdus.Length) As Messagesms
		For i = 0 To pdus.Length - 1
			r.Target = r.RunStaticMethod("android.telephony.SmsMessage", "createFromPdu", _
            Array As Object(pdus(i)), Array As String("[B"))
			messages(i).Body = r.RunMethod("getMessageBody")
			messages(i).Address = r.RunMethod("getOriginatingAddress")
		Next
	End If
	Return messages
End Sub

'******************* Génération Scheduler *******************

Sub JsonScheduler(Mode As Boolean) 'False/True = Read/Write
	
	Try
		If Mode=False Then
				
			JSON.Initialize(File.ReadString(File.DirDefaultExternal, "Scheduler.json"))
		
			SchedulerCommand = JSON.NextObject
	
		
		Else If Mode=True Then
		
			
			' ************************Ajout d'une nouvelle programmation.*********************
		
			If TypeSchedulerAction=CreateScheduler Then
				Private Scheduler As Map
				Private Scheduler_Data As Map
		
				Scheduler.Initialize
				Scheduler_Data.Initialize
		
				Scheduler_Data.Put("SchedulerDays",SchedulerDays)
				Scheduler_Data.Put("SchedulerRepeat",SchedulerRepeat)
				Scheduler_Data.Put("SchedulerActive",SchedulerActive)
				Scheduler_Data.Put("SchedulerDate",SchedulerDate)
				Scheduler_Data.Put("SchedulerTemp",SchedulerTemp)
		
				Scheduler.Put("SchedulerId " & SchedulerId, Scheduler_Data)
				SchedulerCommand.Add(Scheduler)
				jg.Initialize2(SchedulerCommand)
			
				Log(jg.ToPrettyString(4))
			
				File.WriteString(File.DirDefaultExternal,"Scheduler.json",jg.ToPrettyString(4))
			End If
		
		
			' **********************Suppression d'une programmation************************
		
			If TypeSchedulerAction=SupScheduler Then
				'Dim ListofScheduler As Map
			
				For Each L_Map As Map In SchedulerCommand
					Private RefSplit() As String = Regex.Split(" ", L_Map.GetKeyAt(0))
					Private IDSch As Int = RefSplit(1)
					Private index_map As Int=0
				
					'FindSensor =False
					'ListofScheduler= L_Map.Get(L_Map.GetKeyAt(0))
					If IDSch=SchedulerId Then
						index_map=SchedulerCommand.IndexOf(L_Map)
						Exit
					End If
				Next
			
				SchedulerCommand.RemoveAt(index_map)
			
				jg.Initialize2(SchedulerCommand)
			
				Log(jg.ToPrettyString(4))
			
				File.WriteString(File.DirDefaultExternal,"Scheduler.json",jg.ToPrettyString(4))
			End If
		
		
			' *******************Modification d'une programmation*******************
		
			If TypeSchedulerAction=ModifScheduler Then
				'Private Scheduler_Data As Map
				Private ListofScheduler As Map
				'ListofScheduler.Initialize
			
				For Each L_Map As Map In SchedulerCommand
					'L_Map.Initialize
					Private RefSplit() As String = Regex.Split(" ", L_Map.GetKeyAt(0))
					Private IDSch As Int = RefSplit(1)
					Dim index_map As Int=0
					'FindSensor =False
					ListofScheduler= L_Map.Get(L_Map.GetKeyAt(0))
					If IDSch=SchedulerId Then
						index_map=SchedulerCommand.IndexOf(L_Map)
						Exit
					End If
				Next
			
				If SchedulerDays.Size<>0 Then
					ListofScheduler.Put("SchedulerDays",SchedulerDays)
				End If
			
					
				If SchedulerRepeat<>"" Then
					ListofScheduler.Put("SchedulerRepeat",SchedulerRepeat)
				End If
				If SchedulerActive<>"" Then
					ListofScheduler.Put("SchedulerActive",SchedulerActive)
				End If
				If SchedulerDate<>"" Then
					ListofScheduler.Put("SchedulerDate",SchedulerDate)
				End If
				If SchedulerTemp<>"" Then
					ListofScheduler.Put("SchedulerTemp",SchedulerTemp)
				End If
						
				jg.Initialize2(SchedulerCommand)
			
				Log(jg.ToPrettyString(4))
			
				File.WriteString(File.DirDefaultExternal,"Scheduler.json",jg.ToPrettyString(4))
			End If
			
		End If
	Catch
		Log(LastException)
	End Try
	
	
			
End Sub



' Traitement des ordres reçus
Sub Service_Command(Order As String)
	
	Private Data As String=""
	Private Header As String=""
	Private Data_valid As Boolean=False
	Private NbNextMessages As Int=0
	
	
	Private AdminMessage As Int=1
	Private HeaterMessage As Int=2
	Private SchedulerMessage As Int =3
	'Private NbCommand As Int=0
	CallSubDelayed(B4XPages.MainPage,"smsreceived")
	Try
		If Order.SubString2(0,2)="#C" And Order.SubString2((Order.Length-2),Order.Length-1)="@" Then 'Identifie une trame
			
			'NbCommand= Order.SubString2(2,3) 'Nombre de commande constituant le message
			NbNextMessages= Order.SubString2((Order.Length-1),Order.Length) 'Nombre de sms constituant la commande
			
			' Description des ordres
			Private Ident_Header() As String=Regex.Split("#",Order)
			
			
			' Identifie le nombre de commande
			Private Nbre_Header As Int=Ident_Header(1).SubString(1)
						
			If Nbre_Header<>Ident_Header.Length-2 Then
				Send_Succesful_Command(Phone1,"Command Fail")
			Else
				Private Header_Item As Int =0
				For  Header_Item =2 To Ident_Header.Length-1
					Private Datareceived As String= Ident_Header(Header_Item).SubString2(0,Ident_Header(Header_Item).Length-1)
					
					If Datareceived.SubString(Datareceived.Length-1)="@" Then
						Datareceived=Datareceived.SubString2(0,Datareceived.Length-2)
					End If
					' Vérification validité de la trame
					If Datareceived.SubString2(5,6)="%"   Then
						Header = Datareceived.SubString2(0,5)
						Data = Datareceived.SubString2(6,Datareceived.Length)
						Data_valid=True
					End If
							
					If Data_valid=True Then
		
						If Header.SubString2(0,2)="Or" Then 'Admin Command
							TypeMessage=AdminMessage
							Select Case Header
				
								' Admin Command
				
								Case "Or001"
									AdminNumber = Data
																							
								Case "Or002"
									AdminNumber = Data
							
								Case "Or003" 'Create Password
									Adminpassword=Data
							
								Case "Or004" 'Change Password
									
									Dim IdentPassword() As String= Regex.Split(Sep2,Data)
									
									If IdentPassword(0)= Adminpassword Then
										Adminpassword=IdentPassword(1)
									Else
										ErrorMessage="Commande refusée"
									End If
									
						
								Case "Or005"
									Private UsersPhones() As String= Regex.Split(Sep2,Data)
									Private u1 As Int=0
									
									For u1=0 To UsersPhones.Length-1
										AdminUserPhone.Add(UsersPhones(u1))
									Next
												
								Case "Or006"
									Private UsersPhones() As String= Regex.Split(Sep2,Data)
									Private u1 As Int=0
									
									For u1=0 To UsersPhones.Length-1
										AdminUserPhone.Add(UsersPhones(u1))
									Next
														
							End Select
				
						Else if Header.SubString2(0,2)="Hb" Then 'Host Command
							TypeMessage=HeaterMessage
							Select Case Header
			
								' Heater Command
				
								Case "Hb001"
									
				
								Case "Hb002"
									
								Case "Hb003"
																		
								Case "Hb004"
																		
								Case "Hb005"
																		
								Case "Hb006"
									
							End Select
							
						Else if Header.SubString2(0,2)="Sc" Then 'Host Command
							TypeMessage=SchedulerMessage
							Select Case Header
	
								' Scheduler Command
		
								Case "Sc001"
									TypeSchedulerAction=CreateScheduler
									SchedulerId=Data
								Case "Sc002"
									TypeSchedulerAction=SupScheduler
									SchedulerId=Data
								Case "Sc003"
									TypeSchedulerAction=ModifScheduler
									SchedulerId=Data
								Case "Sc004"
									Private DaysList() As String= Regex.Split(Sep2,Data)
									Private u1 As Int=0
									
									For u1=0 To DaysList.Length-1
										SchedulerDays.Add(DaysList(u1))
									Next
									
								Case "Sc005"
									SchedulerRepeat=Data
								Case "Sc006"
									SchedulerActive=Data
								Case "Sc007"
									SchedulerDate=Data
								Case "Sc008"
									SchedulerTemp=Data
							
							End Select
						End If
					End If
				Next
				
				If NbNextMessages= 0 Then MessageCompleted=True
			
			End If
		Else
			
		End If
		
	Catch
		Log(LastException)
	End Try
	
	
	If MessageCompleted=True  Then
		Select TypeMessage
			Case SchedulerMessage
				JsonScheduler(True)
			Case HeaterMessage
			Case AdminMessage
				Json_setup(True)
		End Select
		
		TypeMessage=0
		MessageCompleted=False
		AdminUserPhone.clear
		TypeSchedulerAction=0
		SchedulerId=0
		SchedulerDays.Clear
		SchedulerRepeat=""
		SchedulerActive=""
		SchedulerDate=""
		SchedulerTemp=""
	End If
		
	
End Sub

Sub hg_BatteryChanged (Level As Int, Scale As Int, Plugged As Boolean, Intent As Intent)
	Battery_Level=Level
End Sub

Sub Send_Succesful_Command(Number As String,message As String)
	
	Send_Sms.Send(Number,message)
End Sub

Sub Service_Destroy
	StartServiceAt(Me,DateTime.Now + 2000,True) ' Relance après 2s si service arrêté
End Sub